﻿using System.Windows;

using ICSharpCode.AvalonEdit.Folding;
using ICSharpCode.AvalonEdit.Highlighting;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            this.textEditor.IsReadOnly                                      = true;  // 디폴트 : false
            this.textEditor.Options.AllowScrollBelowDocument                = true;  // 디폴트 : false
            this.textEditor.Options.AllowToggleOverstrikeMode               = true;  // 디폴트 : false
            this.textEditor.Options.ColumnRulerPosition                     = 130;   // 디폴트 : 80
            this.textEditor.Options.ConvertTabsToSpaces                     = true;  // 디폴트 : false
            this.textEditor.Options.CutCopyWholeLine                        = true;  // 디폴트 : true
            this.textEditor.Options.EnableEmailHyperlinks                   = true;  // 디폴트 : true
            this.textEditor.Options.EnableHyperlinks                        = true;  // 디폴트 : true
            this.textEditor.Options.EnableImeSupport                        = true;  // 디폴트 : true
            this.textEditor.Options.EnableRectangularSelection              = true;  // 디폴트 : true
            this.textEditor.Options.EnableTextDragDrop                      = true;  // 디폴트 : true
            this.textEditor.Options.EnableVirtualSpace                      = true;  // 디폴트 : false
            this.textEditor.Options.HideCursorWhileTyping                   = true;  // 디폴트 : true
            this.textEditor.Options.HighlightCurrentLine                    = true;  // 디폴트 : false
            this.textEditor.Options.IndentationSize                         = 4;     // 디폴트 : 4
            this.textEditor.Options.InheritWordWrapIndentation              = true;  // 디폴트 : true
            this.textEditor.Options.RequireControlModifierForHyperlinkClick = true;  // 디폴트 : true
            this.textEditor.Options.ShowBoxForControlCharacters             = true;  // 디폴트 : true
            this.textEditor.Options.ShowColumnRuler                         = true;  // 디폴트 : false
            this.textEditor.Options.ShowEndOfLine                           = false; // 디폴트 : false
            this.textEditor.Options.ShowSpaces                              = false; // 디폴트 : false
            this.textEditor.Options.ShowTabs                                = false; // 디폴트 : false
            this.textEditor.Options.WordWrapIndentation                     = 0;     // 디폴트 : 0
            this.textEditor.ShowLineNumbers                                 = true;  // 디폴트 : false
            this.textEditor.WordWrap                                        = false; // 디폴트 : false

            Loaded += Window_Loaded;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 윈도우 로드시 처리하기 - Window_Loaded(sender, e)

        /// <summary>
        /// 윈도우 로드시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            this.textEditor.Load(@"..\..\MainWindow.xaml.cs");

            #region name
            /*
            XmlDoc
            C#
            JavaScript
            HTML
            ASP/XHTML
            Boo
            Coco
            CSS
            C++
            Java
            Patch
            PowerShell
            PHP
            Python
            TeX
            TSQL
            VB
            XML
            MarkDown
            MarkDownWithFontSize
            Json
            */
            #endregion
            IHighlightingDefinition definition = HighlightingManager.Instance.GetDefinition("C#");
            
            this.textEditor.SyntaxHighlighting = definition; // 디폴트 : null

            FoldingManager foldingManager = FoldingManager.Install(this.textEditor.TextArea);

          //XmlFoldingStrategy   foldingStrategy = new XmlFoldingStrategy();
            BraceFoldingStrategy foldingStrategy = new BraceFoldingStrategy();

            foldingStrategy.UpdateFoldings(foldingManager, this.textEditor.Document);
        }

        #endregion
    }
}